'****************************************************************
'*  Nombre  : ALFA.BAS                                          *
'*  Autor   : ErDaByZ                                           *                      
'*  Versin : 1.5                                               *
'*  Notas   : Ahora con animaciones.                            *
'*          :                                                   *
'****************************************************************
@ device pic16F628A, intrc_osc, wdt_off, pwrt_off, mclr_off, bod_off, protect_off
CMCON = 7

define OSC 4 'oscilador interno a 4  Mhz
pause 500  'quieto medio segundo hasta que te estabilices
PORTA = %00000000 'todo a 0
PORTB = %00000000

NRO var byte   'variable de nmero de palabra
PLETRA Var byte  ' pausa entre letras
PPALABRA var byte  'pausa entre frases
ANIMA VAR BYTE  ' esto es para los fotogramas de la animacion
CLEAR  'todas las variables a 0

PLETRA = 4 'damos valores a las variables

INICIO:    ' y arrancamos
TRISB = %00000000   ' puerto b todo salidas
TRISA = %00000010    'puerto a1 como entrada
IF PORTA.1 = 0 then    'esto es para que al dar al pulsador nos cambie de palabra
pause 100 'esta pausa es para evitar que nos cambie varias veces en una sola pulsacin
nro = nro + 1
endif

IF nro >= 6 Then  'y esto evita que la variable NRO sea mayor que 5 (no hay mas que 5 palabras).
nro = 0            'como al pic le sobra memoria, puedes modificar esto para poner ms palabras
'SI QUERIS PONER 8 PALABRAS,   IF nro >= 9 Then    ENTENDEIS NO?
endif

if nro = 0 then ' esto es para tener al PIC "parado" si damos 6 veces al pulsador (NRO se pone a 0)
goto inicio
endif
'esto de aqui arriba pens arreglarlo con un END, pero luego el pic no despierta..
'por eso pongo interruptor en el diseo, para no gastar pila.
'si alguien consigue hacer despertar el pic del estado de minimo consumo
'que me diga cmo se hace.



IF nro = 1 Then  'esto es para que dependiendo del valor de nro nos lleve a una u otra palabra       
ppalabra = 50   ' y esto es para ajustar la pausa entre cada frase        
GoTo PALABRA1    
EndIF

IF nro = 2 Then       
ppalabra = 50          
GoTo PALABRA2   
EndIF

IF nro = 3 Then        
ppalabra = 50             
GoTo PALABRA3    
EndIF

IF nro = 4 Then        
ppalabra = 50             
GoTo PALABRA4    
EndIF

IF nro = 5 Then        
ppalabra = 45             
GoTo PALABRA5    
EndIF

'esto de arriba puede ser modificado para incluir ms palabras...
'PARA INTRODUCIR UNA NUEVA PALABRA
'IF nro = n Then        
'ppalabra = 45             
'GoTo PALABRA5    
'EndIF
'SIENDO n EL NMERO DE PALABRA. AL CHIP LE SOBRA MEMORIA, CALCULO QUE
'PODIS PONER UNAS 20-30 DIFERENTES...
'tambin hay que modificar esto de abajo:

PALABRA1:   'palabra 1   PRESTAD ATENCIN Y QUE OS SIRVA DE EJEMPLO
pause ppalabra
gosub ABEX
pause pletra
gosub LETRA_W
pause pletra
gosub LETRA_w
pause pletra
gosub LETRA_W
pause pletra
gosub PUNTO
pause pletra
gosub LETRA_E
pause pletra
gosub LETRA_L
pause pletra
gosub LETRA_O
pause pletra
gosub LETRA_T
pause pletra
gosub LETRA_R
pause pletra
gosub LETRA_O
pause pletra
gosub LETRA_L
pause pletra
gosub LETRA_A
pause pletra
gosub LETRA_D
pause pletra
gosub LETRA_O
pause pletra
gosub PUNTO
pause pletra
gosub LETRA_N
pause pletra
gosub LETRA_E
pause pletra
gosub LETRA_T
pause pletra
gosub CEREX
pause pPALABRA
GOTO INICIO

PALABRA2:
pause ppalabra
gosub LETRA_X
pause pPALABRA
GOTO INICIO     

'YA SABES, AQU HAY QUE PONER LA PALABRA. SE EMPIEZA CON UN PAUSE PPALABRA SIEMPRE
'LUEGO CON LA INSTRUCCIN GOSUB VAIS A CADA UNA DE LAS LETRAS
'ENTRE LETRA Y LETRA HAY QUE PONER UN PAUSE PLETRA
'PARA HACER UN ESPACIO PONER DOS VECES SEGUIDAS PAUSE PLETRA
'AL FINAL, TERMINAR CON UN PAUSE PPALABRA
'GOSUB INICIO
'Y LISTO. SI ALGUIEN QUIERE HACER ALGN PROGRAMILLA PARA QUE TE GENERE AUTOMTICAMENTE
'EL CDIGO DE LA PALABRA, ES LIBRE DE HACERLO.
PALABRA3:    '3
pause ppalabra
gosub LETRA_X
pause pPALABRA
GOTO INICIO

PALABRA4:     '4
pause ppalabra
gosub LETRA_X
pause pPALABRA
GOTO INICIO

PALABRA5:
pause ppalabra
gosub LETRA_X
pause pPALABRA
GOTO INICIO    '5



'y ahora el alfabeto, esto dice al pic cmo tiene que poner las salidas para formar
'la letra en el aire. mejor no tocar aqu....




LETRA_A:
PORTB= %00000000
PORTB= %01111110
pause 2
PORTB= %00001001
PAUSE 4
PORTB= %01111110
PAUSE 2
PORTB= %00000000
RETURN


LETRA_B:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %01001001
PAUSE 4
PORTB= %00110110
PAUSE 2
PORTB= %00000000
RETURN


LETRA_C:
PORTB= %00000000
PORTB= %00111110
pause 2
PORTB= %01000001
PAUSE 4
PORTB= %00100010
pause 2
PORTB= %00000000
RETURN

LETRA_D:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %01000001
PAUSE 2
PORTB= %00100010
PAUSE 2
PORTB= %00011100
pause 2
PORTB= %00000000
RETURN

LETRA_E:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %01001001
PAUSE 6
PORTB= %00000000
RETURN


LETRA_F:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00001001
PAUSE 4
PORTB= %00000001
PAUSE 2
PORTB= %00000000
RETURN

LETRA_G:
PORTB= %00000000
PORTB= %00111110
pause 2
PORTB= %01000001
PAUSE 2
PORTB= %01001001
PAUSE 2
PORTB= %00111001
PAUSE 2
PORTB= %00000000
RETURN

LETRA_H:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00001000
PAUSE 4
PORTB= %01111111
PAUSE 2
PORTB= %00000000
RETURN

LETRA_I:
PORTB= %00000000
PORTB= %01000001
pause 2
PORTB= %01111111
PAUSE 2
PORTB= %01000001
PAUSE 2
PORTB= %00000000
RETURN
        
LETRA_J:
PORTB= %00000000
PORTB= %01000001
pause 4
PORTB= %00111111
PAUSE 2
PORTB= %00000001
PAUSE 2
PORTB= %00000000
RETURN

LETRA_K:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00001000
PAUSE 2
PORTB= %00110110
PAUSE 2
PORTB= %01000001
PAUSE 2
PORTB= %00000000
RETURN

LETRA_L:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %01000000
PAUSE 6
PORTB= %00000000
RETURN

LETRA_M:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00000010
PAUSE 2
PORTB= %00000100
PAUSE 2
PORTB= %00000010
PAUSE 2
PORTB= %01111111
PAUSE 2
PORTB =%00000000
RETURN

LETRA_N:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00000110
PAUSE 2
PORTB= %00001000
PAUSE 2
PORTB= %00110000
PAUSE 2
PORTB= %01111111
pause 2
PORTB =%00000000
RETURN

LETRA_NY:
PORTB= %00000000
PORTB= %01111101
pause 2
PORTB= %00001010
PAUSE 2
PORTB= %00010001
PAUSE 2
PORTB= %00100010
PAUSE 2
PORTB= %01111101
pause 2
PORTB =%00000000
RETURN

LETRA_O:
PORTB= %00000000
PORTB= %00111110
pause 2
PORTB= %01000001
PAUSE 6
PORTB= %00111110
PAUSE 2
PORTB= %00000000
RETURN

LETRA_P:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00001001
PAUSE 4
PORTB= %00000110
PAUSE 2
PORTB= %00000000
RETURN

LETRA_Q:
PORTB= %00000000
PORTB= %00011100
pause 2
PORTB= %00100010
PAUSE 2
PORTB= %01010001
PAUSE 2
PORTB= %00100010
pause 2
PORTB= %01011100
pause 2
PORTB= %00000000
RETURN

LETRA_R:
PORTB= %00000000
PORTB= %01111111
pause 2
PORTB= %00011001
PAUSE 2
PORTB= %00101001
PAUSE 2
PORTB= %01000110
PAUSE 2
PORTB= %00000000
RETURN

LETRA_S:
PORTB= %00000000
PORTB= %01000110
pause 2
PORTB= %01001001
PAUSE 4
PORTB= %00110001
PAUSE 2
PORTB= %00000000
RETURN

LETRA_T:
PORTB= %00000000
PORTB= %00000001
pause 4
PORTB= %01111111
PAUSE 2
PORTB= %00000001
PAUSE 4
PORTB= %00000000
RETURN

LETRA_U:
PORTB= %00000000
PORTB= %00111111
pause 2
PORTB= %01000000
PAUSE 4
PORTB= %00111111
PAUSE 2
PORTB= %00000000
RETURN  

LETRA_V:
PORTB= %00000000
PORTB= %00011111
pause 2
PORTB= %00100000
PAUSE 2
PORTB= %01000000
PAUSE 2
PORTB= %00100000
PAUSE 2
PORTB= %00011111
PAUSE 2
PORTB= %00000000
RETURN

LETRA_W:
PORTB= %00000000
PORTB= %00111111
pause 2
PORTB= %01000000
PAUSE 2
PORTB= %00110000
PAUSE 2
PORTB= %01000000
PAUSE 2
PORTB= %00111111
PAUSE 2
PORTB= %00000000
RETURN

LETRA_X:
PORTB= %00000000
PORTB= %01100011
pause 2
PORTB= %00010100
PAUSE 2
PORTB= %00001000
PAUSE 2
PORTB= %01010100
PAUSE 2
PORTB= %01100011
PAUSE 2
PORTB= %00000000
RETURN

LETRA_Y:
PORTB= %00000000
PORTB= %00000001
pause 2
PORTB= %00000010
PAUSE 2
PORTB= %01111100
PAUSE 2
PORTB= %01000010
PAUSE 2
PORTB= %00000001
PAUSE 2
PORTB= %00000000
RETURN

LETRA_Z:
PORTB= %00000000
PORTB= %01100001
pause 2
PORTB= %01011001
PAUSE 2
PORTB= %01001001
PAUSE 2
PORTB= %01001101
PAUSE 2
PORTB= %01000011
PAUSE 2
PORTB= %00000000
RETURN 
        'apertura/cierre interrogacin
ABINT:
PORTB= %00000000
PORTB= %00110000
pause 2
PORTB= %01001000
PAUSE 2
PORTB= %01000101
PAUSE 2
PORTB= %00100000
PAUSE 2
PORTB= %00000000
RETURN

CERINT:
PORTB= %00000000
PORTB= %00000010
pause 2
PORTB= %01010001
PAUSE 2
PORTB= %00001001
PAUSE 2
PORTB= %00000110
PAUSE 2
PORTB= %00000000
RETURN
        'apertura/cierre exclamacin.
CEREX:
PORTB= %00000000
PORTB= %01011111
pause 2
PORTB= %00000000
RETURN

ABEX:
PORTB= %00000000
PORTB= %01111101
pause 2
PORTB= %00000000
RETURN
' punto, coma y punto y coma
PUNTO:
PORTB= %00000000
PORTB= %01000000
pause 2
PORTB= %00000000
RETURN

COMA:
PORTB= %00000000
PORTB= %01000000
pause 2
PORTB= %00110000
pause 2
PORTB= %00000000
RETURN

DOTCOMA:
PORTB= %00000000
PORTB= %01000000
pause 2
PORTB= %00110100
pause 2
PORTB= %00000000
RETURN

'abrir/cerrar parentesis
ABPAR:
PORTB= %00000000
PORTB= %00111110
pause 2
PORTB= %01000001
pause 2
PORTB= %00000000
RETURN

CERPAR:
PORTB= %00000000
PORTB= %01000001
pause 2
PORTB= %00111110
pause 2
PORTB= %00000000
RETURN
'el smbolo del Lero


EURO:
PORTB= %00000000
PORTB= %00010100
pause 2
PORTB= %00011100
PAUSE 2
PORTB= %00110110
PAUSE 2
PORTB= %01010101
PAUSE 2
PORTB= %01000101
PAUSE 2
PORTB= %00100010
PAUSE 2
PORTB= %00000000
RETURN

'suma, resta, igual
MAS:
PORTB= %00000000
PORTB= %00001000
pause 4
PORTB= %00111110
PAUSE 2
PORTB= %00001000
PAUSE 4
PORTB= %00000000
RETURN

MENOS:
PORTB= %00000000
PORTB= %00001000
pause 8
PORTB= %00000000
RETURN

IGUAL:
PORTB= %00000000
PORTB= %00010100
pause 8
PORTB= %00000000
RETURN






'ahora los nmeros 


CERO:
PORTB= %00000000
PORTB= %00111110
pause 2
PORTB= %01000001
PAUSE 4
PORTB= %00111110
PAUSE 2
PORTB= %00000000
RETURn

UNO:
PORTB= %00000000
PORTB= %00000100
pause 2
PORTB= %00000010
PAUSE 2
PORTB= %01111111
PAUSE 2
PORTB= %00000000
RETURn



DOS:
PORTB= %00000000
PORTB= %01100010
pause 2
PORTB= %01010001
PAUSE 2
PORTB= %01001001
PAUSE 2
PORTB= %01000110
PAUSE 2
PORTB= %00000000
RETURN

TRES:
PORTB= %00000000
PORTB= %00100010
pause 2
PORTB= %01001001
PAUSE 4
PORTB= %00110110
PAUSE 2
PORTB= %00000000
RETURn

CUATRO:
PORTB= %00000000
PORTB= %00001111
pause 2
PORTB= %00001000
PAUSE 4
PORTB= %01111111
PAUSE 2
PORTB= %00000000
RETURn

CINCO:
PORTB= %00000000
PORTB= %00101111
pause 2
PORTB= %01000101
PAUSE 4
PORTB= %00111001
PAUSE 2
PORTB= %00000000
RETURn

SEIS:
PORTB= %00000000
PORTB= %00111110
pause 2
PORTB= %01001001
PAUSE 4
PORTB= %00110010
PAUSE 2
PORTB= %00000000
RETURn

SIETE:
PORTB= %00000000
PORTB= %01100001
pause 2
PORTB= %00010001
PAUSE 2
PORTB= %00001001
PAUSE 2
PORTB= %00000111
pause 2
PORTB= %00000000
RETURn

OCHO:
PORTB= %00000000
PORTB= %00110110
pause 2
PORTB= %01001001
PAUSE 4
PORTB= %00110110
PAUSE 2
PORTB= %00000000
RETURn

NUEVE:
PORTB= %00000000
PORTB= %00100110
pause 2
PORTB= %01001001
PAUSE 4
PORTB= %00111110
PAUSE 2
PORTB= %00000000
RETURn
                       'estas son las animaciones que hay, es una X dando vueltas que cambia
                       'a cada ciclo de la frase y un corazon que late.
                       'se pueden incluir ms
ANIM:
IF ANIMA = 0 THEN
PORTB= %00000000
PORTB= %01100011
pause 2
PORTB= %00110110
PAUSE 2
PORTB= %00001000
PAUSE 2
PORTB= %00110110
PAUSE 2
PORTB= %01100011
PAUSE 2
PORTB= %00000000
ANIMA = 1
RETURn
ELSE
PORTB= %00000000
PORTB= %00100010
pause 2
PORTB= %00110110
PAUSE 2
PORTB= %00010100
PAUSE 2
PORTB= %00001000
PAUSE 2
PORTB= %00010100
PAUSE 2
PORTB= %00110110
PAUSE 2
PORTB= %00100010
PAUSE 2
PORTB= %00000000
RETURN
ANIMA = 0
ENDIF
       
CORAZON:
IF ANIMA = 0 THEN
PORTB= %00000000
PORTB= %00000110
pause 2
PORTB= %00001111
PAUSE 2
PORTB= %00011110
PAUSE 2
PORTB= %00001111
PAUSE 2
PORTB= %00000110
PAUSE 2
PORTB= %00000000
ANIMA = 1
RETURn
else
PORTB= %00000000
PORTB= %00000110
pause 2
PORTB= %00001111
pause 2
PORTB= %00011111
PAUSE 2
PORTB= %00111110
PAUSE 2
PORTB= %00011111
PAUSE 2
PORTB= %00001111
PAUSE 2
PORTB= %00000110
PAUSE 2
PORTB= %00000000
anima=0
RETURN
ENDIF


'ESPERO QUE OS GUSTE, SI QUEREIS MODIFICAR EL CDIGO SOIS LIBRES DE HACERLO.
'HE PUESTO UN ALFABETO BASTANTE COMPELTITO, INCLUSO CON DOS ANIMACIONES
'QUE FUNCIONAN IGUAL QUE CUALQUIER LETRA:  GOSUB ANIM  GOSUB CORAZON 
'SI QUERIS AADIR NUEVOS SMBOLOS, PODIS VER CMO ESTAN PUESTOS LOS YA EXISTENTES PARA
'SABER COMO CREAR ALGUNO NUEVO.

































